Unit AEB6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AV02R_p, AV04R_p;

procedure AEB6R(NM :Integer; N :Integer; M1 :Integer;
                var B :Array of Real; var C :Array of Real;
                var EV :Array of Real; L :Integer; L0 :Integer;
                var V :Array of Real; var Z :Array of Real;
                var W :Array of Real; var LOG :Array of Boolean;
                var IERR :Integer);

implementation

procedure AEB6R(NM :Integer; N :Integer; M1 :Integer;
                var B :Array of Real; var C :Array of Real;
                var EV :Array of Real; L :Integer; L0 :Integer;
                var V :Array of Real; var Z :Array of Real;
                var W :Array of Real; var LOG :Array of Boolean;
                var IERR :Integer);
var
M,N1,M21,J,J0,J1,J2,I,I1,MET,L1,LI,MI,JK,M2K,M0,MET1,IERR1,IND1,IT,
   IND,K,M01,KI,IT0,LI1 :Integer;
R,XMAX,XMIN,EPS,EPS2,X,R1,D,S,S0,S1,SK,F :Real;
const
RELMCH :Real = 5.9604645E-8;
label
_1,_5,_10,_20,_25,_30,_35,_40,_46,_50,_52,_55,_60,_70,_80,_90,_100,
_130,_110,_120,_133,_135,_140,_145,_147,_148,_156,_157,_150,_152,_155,
_160,_153,_154,_159,_161,_165,_180,_190,_200,_205,_210,_215,_220,_273,
_274,_270,_275,_285,_290,_250,_294,_295,_300,_310;
begin
M := M1-1;
IERR1 := IERR;
MET := 25;
N1 := N+1;
M21 := M*2+1;
if ( N = 1 )
 then V[0+(L-1)*NM] := 1.0;
if ( N = 1 )
 then goto _310;
{   OPM-E MACCBA C }
_1:
{   C - KOMAKTHA OPMA  CXOHO MATP  A }
{       /CTAH. OPMA  HECCMETP. EHTOHO  MATP/ }
if ( M = 0 )
 then begin
       if ( MET=25 ) then goto _25 else
       if ( MET=46 ) then goto _46;
      end;
for J:=1 to M do
 begin
  J0 := M1-J;
  J1 := J0+1;
  J2 := M21+1-J;
  J1 := Min0(J1,N);
  for I:=J1 to N do
   begin
    R := B[(I-1)+(J-1)*NM];
    C[(I-1)+(J-1)*N] := R;
    I1 := I-J0;
    C[(I1-1)+(J2-1)*N] := R;
_5:
   end;
  for I:=1 to J0 do
   begin
    C[(I-1)+(J-1)*N] := 0.0;
    I1 := N1-I;
    C[(I1-1)+(J2-1)*N] := 0.0;
_10:
   end;
_20:
 end;
if ( MET=25 ) then goto _25 else
if ( MET=46 ) then goto _46;
{   B-E PAH EPOPHA  CXOHO MATP }
_25:
XMAX := B[0+(M1-1)*NM];
XMIN := B[0+(M1-1)*NM];
for I:=1 to N do
 begin
  S := 0.0;
  if ( M = 0 )
   then goto _35;
  for J:=1 to M do
   begin
    J1 := J+M1;
    S := S+Abs(C[(I-1)+(J-1)*N])+Abs(C[(I-1)+(J1-1)*N]);
_30:
   end;
_35:
  XMAX := EMax1(XMAX,B[(I-1)+(M1-1)*NM]+S);
  XMIN := EMin1(XMIN,B[(I-1)+(M1-1)*NM]-S);
_40:
 end;
R := EMax1(Abs(XMAX),Abs(XMIN));
EPS := R*RELMCH;
if ( EPS = 0.0 )
 then EPS := RELMCH;
R1 := Sqrt(RELMCH);
S := Sqrt(R1);
EPS2 := R*S;
if ( EPS2 = 0.0 )
 then EPS2 := S;
MET := 46;
{    B-E C.B-POB }
L1 := L0+1;
//for LI:=L1 to L do
//  , ..        goto
LI := L1;
while LI<=L do
 begin
  X := EV[LI-1];
  IND1 := 0;
  goto _1;
_46:
{   C - KOMAKTHA OPMA  MATP  A - X*I }
  for I:=1 to N do
   begin
    C[(I-1)+(M1-1)*N] := B[(I-1)+(M1-1)*NM]-X;
_50:
   end;
  if ( M <> 0 )
   then goto _55;
  for I:=1 to N do
   begin
    if ( Abs(C[(I-1)+0*N]) < EPS )
     then C[(I-1)+0*N] := EPS;
_52:
   end;
  MET1 := 150;
  IT := 0;
  IND := 0;
  goto _150;
_55:
  K := M;
  MI := M1;
  for I:=1 to M do
   begin
    for J:=MI to M21 do
     begin
      JK := J-K;
      C[(I-1)+(JK-1)*N] := C[(I-1)+(J-1)*N];
_60:
     end;
    MI := K;
    K := K-1;
    M2K := M21-K;
    for J:=M2K to M21 do
     begin
      C[(I-1)+(J-1)*N] := 0.0;
_70:
     end;
_80:
   end;
{   PBEEHE MATP  A - X*I  K BEPXHEMY TPEYOHOMY BY }
{   METOOM AYCCA C EPECTAHOBKAM }
  if ( Abs(C[0+0*N]) < EPS )
   then C[0+0*N] := EPS;
  for K:=2 to N do
   begin
    M0 := Min0(M,K-1);
    M01 := M0+1;
    for I1:=1 to M0 do
     begin
      I := M01-I1;
      KI := K-I;
      LOG[(K-1)+(I-1)*N] := True;
      R := C[(K-1)+0*N];
      D := C[(KI-1)+0*N];
      if ( Abs(D) > Abs(R) )
       then goto _100;
      if ( R = 0.0 )
       then goto _110;
      for J:=1 to M21 do
       begin
        S := C[(K-1)+(J-1)*N];
        C[(K-1)+(J-1)*N] := C[(KI-1)+(J-1)*N];
        C[(KI-1)+(J-1)*N] := S;
_90:
       end;
      S := R;
      R := D;
      D := S;
      LOG[(K-1)+(I-1)*N] := False;
_100:
      S := R/D;
      W[(K-1)+(I-1)*N] := S;
      for J:=2 to M21 do
       begin
        C[(K-1)+(J-2)*N] := C[(K-1)+(J-1)*N]-S*C[(KI-1)+(J-1)*N];
_130:
       end;
      C[(K-1)+(M21-1)*N] := 0.0;
_110:
     end;
    if ( Abs(C[(K-1)+0*N]) < EPS )
     then C[(K-1)+0*N] := EPS;
_120:
   end;
  IND := 0;
  MET1 := 135;
  if ( IERR1 = 1 )
   then MET1 := 145;
_133:
  IT := 0;
  if ( MET1=135 ) then goto _135 else
  if ( MET1=145 ) then goto _145 else
  if ( MET1=150 ) then goto _150 else
  if ( MET1=156 ) then goto _156;
_135:
  for I:=1 to N do
   begin
    Z[I-1] := EPS;
_140:
   end;
  S0 := EPS*N;
  IT0 := 1;
  MET1 := 156;
  goto _160;
_145:
  S0 := 0.0;
  for I:=1 to N do
   begin
    R := V[(I-1)+(LI-1)*NM];
    Z[I-1] := R;
    S0 := S0+Abs(R);
_147:
   end;
  if ( S0 <= RELMCH )
   then goto _135;
  R := 1.0/S0;
  for I:=1 to N do
   begin
    Z[I-1] := Z[I-1]*R;
_148:
   end;
  S0 := EPS;
  IT0 := 1;
  MET1 := 135;
  goto _160;
_156:
  for I:=1 to N do
   begin
    Z[I-1] := EPS;
_157:
   end;
  S0 := EPS*N;
  IT0 := 2;
  MET1 := 150;
  goto _205;
_150:
  for I:=1 to N do
   begin
_152:
    Z[I-1] := 0.0;
   end;
  IT0 := 1;
  if ( IND = N ) and ( IND1 = M )
   then goto _290;
  if ( IND <> N )
   then goto _155;
  IND1 := IND1+1;
  X := X+EPS;
  goto _1;
_155:
  IND := IND+1;
  Z[IND-1] := EPS;
  S0 := EPS;
{  OPT- }
_160:
  LI1 := LI-1;
  if ( LI1 = 0 )
   then goto _159;
  for J1:=1 to LI1 do
   begin
    if ( Abs(EV[J1-1]-X) > EPS2 )
     then goto _154;
    R := AV04R(V[0+(J1-1)*NM],Z,N);
    for I:=1 to N do
     begin
      Z[I-1] := Z[I-1]-R*V[(I-1)+(J1-1)*NM];
_153:
     end;
_154:
   end;
_159:
  S1 := 0.0;
  for I:=1 to N do
   begin
    S1 := S1+Abs(Z[I-1]);
_161:
   end;
  if ( S1 <= S0/(N) )
   then begin
         if ( MET1=135 ) then goto _135 else
         if ( MET1=145 ) then goto _145 else
         if ( MET1=150 ) then goto _150 else
         if ( MET1=156 ) then goto _156;
        end;
  SK := S1/EPS;
_165:
{  PMA OCTAHOBKA }
  if ( M = 0 )
   then goto _205;
  for K:=2 to N do
   begin
    M0 := Min0(M,K-1);
    M01 := M0+1;
    for I1:=1 to M0 do
     begin
      I := M01-I1;
      KI := K-I;
      if ( LOG[(K-1)+(I-1)*N] )
       then goto _180;
      S := Z[K-1];
      Z[K-1] := Z[KI-1];
      Z[KI-1] := S;
_180:
      S := W[(K-1)+(I-1)*N];
      Z[K-1] := Z[K-1]-S*Z[KI-1];
_190:
     end;
_200:
   end;
_205:
{  OPATHA OCTAHOBKA }
  for I1:=1 to N do
   begin
    I := N1-I1;
    S := Z[I-1];
    J0 := I-1;
    J1 := Min0(I1,M21);
    if ( J1 = 1 )
     then goto _215;
    for J:=2 to J1 do
     begin
      J2 := J+J0;
      S := S-C[(I-1)+(J-1)*N]*Z[J2-1];
_210:
     end;
_215:
    Z[I-1] := S/C[(I-1)+0*N];
_220:
   end;
  IT := IT+1;
  LI1 := LI-1;
  if ( LI1 = 0 )
   then goto _270;
  for J1:=1 to LI1 do
   begin
    if ( Abs(EV[J1-1]-X) > EPS2 )
     then goto _274;
    R := AV04R(V[0+(J1-1)*NM],Z,N);
    for I:=1 to N do
     begin
      Z[I-1] := Z[I-1]-R*V[(I-1)+(J1-1)*NM];
_273:
     end;
_274:
   end;
_270:
  S1 := 0.0;
  for I:=1 to N do
   begin
    S1 := S1+Abs(Z[I-1]);
_275:
   end;
  if ( S1 > SK*1.E-1/N ) and ( IT >= IT0 )
   then goto _250;
  if ( S1 <= R1 ) or ( IT = 2 )
   then goto _133;
  for I:=1 to N do
   begin
    Z[I-1] := (Z[I-1]/S1)*EPS;
_285:
   end;
  SK := 1.0;
  goto _165;
_290:
  IERR := LI;
  F := 0.0;
  goto _294;
_250:
  F := 1.0/AV02R(Z,N);
_294:
  for I:=1 to N do
   begin
    V[(I-1)+(LI-1)*NM] := Z[I-1]*F;
_295:
   end;
_300:
  inc(LI); //  
 end;
_310:
end;

end.
